## Index

### Classes

- Analytics
- BlueBase
- BlueBaseApp
- BlueBaseHook
- BlueBaseModuleRegistry
- ComponentRegistry
- ComponentState
- ConfigRegistry
- DataObserver
- DynamicIcon
- ErrorObserver
- ErrorState
- HookRegistry
- HoverObserver
- JsonSchema
- JsonSchemaParser
- LoadingState
- Logger
- PluginIcon
- PluginRegistry
- Registry
- StatefulComponent
- SystemApp
- SystemContent
- ThemeDemo
- ThemePicker
- ThemeProvider
- ThemeRegistry
- ThemedCard
- WaitObserver
- Welcome

### Interfaces

- AnalyticsTrackData
- BlueBaseAppProps
- BlueBaseAppState
- BlueBaseHookProps
- BlueBaseModule
- BlueBaseModuleRegistryInputItem
- BlueBaseModuleRegistryItem
- BootOptions
- ButtonProps
- ButtonStyles
- ComponentRegistryItemExtras
- ComponentSource
- ComponentStateProps
- ComponentStateStyles
- ComponentStyles
- Configs
- DataObserverChildrenProps
- DataObserverProps
- DataObserverState
- DynamicIconProps
- EmptyStateProps
- ErrorObserverProps
- ErrorObserverState
- ErrorStateProps
- Fields
- FieldsInternal
- HookRegistryInputItem
- HookRegistryItemProps
- HoverObserverProps
- HoverObserverState
- JsonComponentNode
- JsonSchemaProps
- LoadingStateProps
- MouseEventObject
- ObjectMapperField
- Palette
- PaletteColor
- PaletteInput
- PluginIconProps
- PluginRegistryItemExtras
- PluginValue
- RegistryInputItem
- RegistryItem
- StatefulComponentProps
- SystemAppProps
- SystemContentProps
- TextProps
- ThemeContextData
- ThemeDemoProps
- ThemeProviderProps
- ThemeProviderState
- ThemeRegistryItemExtras
- ThemeTypography
- ThemeTypographyInput
- ThemeValue
- ThemeValueInput
- ThemedCardProps
- ThemedComponentProps
- ThirdPartyButtonProps
- TypeAction
- TypeBackground
- TypeText
- WaitObserverChildrenProps
- WaitObserverProps
- WaitObserverState

### Type aliases

- ComponentCollection
- ComponentRegistryHocItem
- ComponentRegistryHocItemWithArgs
- ComponentRegistryInputItem
- ComponentRegistryItem
- ComponentWithDefaultStyles
- EsModule
- Hook
- HookHandlerFn
- HookInput
- HookInputCollection
- HookNestedCollection
- HookRegistryItem
- ItemCollection
- ItemInputType
- ItemType
- MaybeArray
- MaybeBlueBaseModule
- MaybeEsModule
- MaybePromise
- MaybeRenderPropChildren
- MaybeThunk
- Omit
- Plugin
- PluginCategory
- PluginCollection
- PluginInput
- PluginRegistryInputItem
- PluginRegistryItem
- PluginValueInput
- RegistrySubscriptionFn
- RenderPropChildren
- ResolveComponentFn
- Theme
- ThemeCollection
- ThemeInput
- ThemeRegistryInputItem
- ThemeRegistryItem
- Thunk
- TypeDivider
- foo

### Variables

- ActivityIndicator
- BlueBaseConsumer
- BlueBaseContext
- BlueBaseProvider
- Body1
- Body2
- Caption
- DEFAULT_HOOK_PRIORITY
- H1
- H2
- H3
- H4
- H5
- H6
- Image
- MISSING_ERROR
- Overline
- Subtitle1
- Subtitle2
- ThemeConsumer
- ThemeContext
- View
- collection
- fontFamily
- global
- isWeb
- palette
- process
- theme
- typography

### Functions

- Bang
- BangNull
- Button
- EmptyState
- HOC
- Noop
- Post
- ReactLoadableLoading
- Text
- ThirdPartyButton
- Timeline
- applyStyles
- buildTheme
- componentMapper
- createBlueBaseModule
- createPalette
- createPlugin
- createTheme
- createTypography
- getComponent
- getDefiniteArray
- getDefiniteBlueBaseModule
- getDefiniteModule
- getDefinitePromise
- inputToPlugin
- isBlueBaseModule
- isEsModule
- isProduction
- isPromise
- isThunk
- makeId
- objectMapper
- processMapperFields
- renderChildrenWithProps
- resolveThunk

### Object literals

- BlueBaseDarkTheme
- BlueBaseDefaultConfigs
- BlueBaseLightTheme
- FontWeight
- boot
- caseAllCaps
- common
- components
- configs
- dark
- light
- plugins
- themes

## Type aliases

### ComponentCollection

ComponentCollection: ItemCollection<ComponentRegistryInputItem>

- Defined in registries/ComponentRegistry.ts:42

### ComponentRegistryHocItem

ComponentRegistryHocItem: function

- Defined in registries/ComponentRegistry.ts:17

Definition of the HOC

#### Type declaration

- - (...args: any[]): React.ComponentType<any>

  - #### Parameters

    - ##### Rest ...args: any[]

    #### Returns React.ComponentType<any>

### ComponentRegistryHocItemWithArgs

ComponentRegistryHocItemWithArgs: [Thunk<ComponentRegistryHocItem>, T]

- Defined in registries/ComponentRegistry.ts:19

### ComponentRegistryInputItem

ComponentRegistryInputItem: BlueBaseModuleRegistryInputItem<React.ComponentType<any>> & Partial<ComponentRegistryItemExtras>

- Defined in registries/ComponentRegistry.ts:39

### ComponentRegistryItem

ComponentRegistryItem: BlueBaseModuleRegistryItem<React.ComponentType<any>> & ComponentRegistryItemExtras

- Defined in registries/ComponentRegistry.ts:36

### ComponentWithDefaultStyles

ComponentWithDefaultStyles: React.ComponentType<any> & object

- Defined in themes/helpers/applyStyles.tsx:8

### EsModule

EsModule: object

- Defined in utils/Modules.ts:4

An ES Module

#### Type declaration

- ##### [key: string]: any

- ##### Optional __esModule?: undefined | false | true

- ##### default: T

### Hook

Hook: HookRegistryItemProps & object

- Defined in registries/HookRegistry.ts:76

Hook Type.

### HookHandlerFn

HookHandlerFn: function

- Defined in registries/HookRegistry.ts:37

The handler function of a hook object. This is the function that is called for each hook, during execution.

This may or may not be an async function.

param

  The input value

param

  Any arguments passed on to the listener by the caller

param

  The BlueBase context

returns

  Original or mutated version of input value. May be a promise that resolves the value.

#### Type declaration

- - (value: T, args: object, BB: BlueBase): T | Promise<T>

  - #### Parameters

    - ##### value: T

    - ##### args: object

      - ##### [key: string]: any

    - ##### BB: BlueBase

    #### Returns T | Promise<T>

### HookInput

HookInput: HookRegistryInputItem

- Defined in registries/HookRegistry.ts:81

HookInput.

### HookInputCollection

HookInputCollection: ItemCollection<HookInput>

- Defined in registries/HookRegistry.ts:83

### HookNestedCollection

HookNestedCollection: MaybeThunk<object>

- Defined in registries/HookRegistry.ts:88

A nested hook collection.

### HookRegistryItem

HookRegistryItem: BlueBaseModuleRegistryItem<HookHandlerFn> & HookRegistryItemProps

- Defined in registries/HookRegistry.ts:62

### ItemCollection

ItemCollection: Array<T | T["value"]> | object

- Defined in registries/Registry.ts:38

A collection of input items. Used by `registerCollection` function.

### ItemInputType

ItemInputType: PluginRegistryInputItem

- Defined in registries/HookRegistry.ts:71
- Defined in registries/ThemeRegistry.ts:38
- Defined in registries/PluginRegistry.ts:63

### ItemType

ItemType: PluginRegistryItem

- Defined in registries/HookRegistry.ts:70
- Defined in registries/ThemeRegistry.ts:37
- Defined in registries/PluginRegistry.ts:62

### MaybeArray

MaybeArray: T | T[]

- Defined in utils/Collections.ts:4

An object that may or may not be an array

### MaybeBlueBaseModule

MaybeBlueBaseModule: BlueBaseModule<T> | T

- Defined in utils/BlueBaseModule.ts:19

An object that may or may not be an instance of BlueBaseModule

### MaybeEsModule

MaybeEsModule: EsModule<T> | T

- Defined in utils/Modules.ts:13

An object that may or may not be an ES Module

### MaybePromise

MaybePromise: T | Promise<T>

- Defined in utils/Promises.ts:4

An object that may or may not be a Promise

### MaybeRenderPropChildren

MaybeRenderPropChildren: RenderPropChildren<T> | React.ReactNode

- Defined in utils/Components.ts:3

### MaybeThunk

MaybeThunk: T | Thunk<T>

- Defined in utils/Thunks.ts:9

An object that may or may not be a Thunk

### Omit

Omit: Pick<T, Exclude<keyof T, K>>

- Defined in utils/Typescript.ts:24

Omit certains keys from an object type.

## Example:

    interface Test {
     a: string;
     b: number;
     c: boolean;
    }

Omit a single property:

    type OmitA = Omit<Test, "a">; // Equivalent to: {b: number, c: boolean}

Or, to omit multiple properties:

    type OmitAB = Omit<Test, "a"|"b">; // Equivalent to: {c: boolean}

### Plugin

Plugin: PluginRegistryItemExtras & PluginValue

- Defined in registries/PluginRegistry.ts:65

### PluginCategory

PluginCategory: "app" | "store" | "router" | "logging" | "theme" | "analytics" | string

- Defined in registries/PluginRegistry.ts:14

### PluginCollection

PluginCollection: ItemCollection<PluginInput>

- Defined in registries/PluginRegistry.ts:68

### PluginInput

PluginInput: PluginRegistryInputItem

- Defined in registries/PluginRegistry.ts:66

### PluginRegistryInputItem

PluginRegistryInputItem: BlueBaseModuleRegistryInputItem<PluginValueInput>

- Defined in registries/PluginRegistry.ts:60

### PluginRegistryItem

PluginRegistryItem: BlueBaseModuleRegistryItem<PluginValue> & PluginRegistryItemExtras

- Defined in registries/PluginRegistry.ts:59

### PluginValueInput

PluginValueInput: Partial<PluginValue>

- Defined in registries/PluginRegistry.ts:30

### RegistrySubscriptionFn

RegistrySubscriptionFn: function

- Defined in registries/Registry.ts:45

Callback function called when a subscription update is published.

#### Type declaration

- - (value: ItemType["value"], item: ItemType): void

  - #### Parameters

    - ##### value: ItemType["value"]

    - ##### item: ItemType

    #### Returns void

### RenderPropChildren

RenderPropChildren: function

- Defined in utils/Components.ts:1

#### Type declaration

- - (props: Props): React.ReactNode

  - #### Parameters

    - ##### props: Props

    #### Returns React.ReactNode

### ResolveComponentFn

ResolveComponentFn: function

- Defined in lib/json-schema-parser/JsonSchemaParser.ts:20

#### Type declaration

- - (node: JsonComponentNode): React.ComponentType<any> | null

  - #### Parameters

    - ##### node: JsonComponentNode

    #### Returns React.ComponentType<any> | null

### Theme

Theme: ThemeRegistryItemExtras & ThemeValue

- Defined in registries/ThemeRegistry.ts:40

### ThemeCollection

ThemeCollection: ItemCollection<ThemeInput>

- Defined in registries/ThemeRegistry.ts:43

### ThemeInput

ThemeInput: ThemeRegistryInputItem

- Defined in registries/ThemeRegistry.ts:41

### ThemeRegistryInputItem

ThemeRegistryInputItem: BlueBaseModuleRegistryInputItem<ThemeValueInput>

- Defined in registries/ThemeRegistry.ts:35

### ThemeRegistryItem

ThemeRegistryItem: BlueBaseModuleRegistryItem<ThemeValue> & ThemeRegistryItemExtras

- Defined in registries/ThemeRegistry.ts:34

### Thunk

Thunk: function

- Defined in utils/Thunks.ts:4

A thunk is function that wraps an expression to delay its evaluation.

#### Type declaration

- - (...params: any[]): T

  - #### Parameters

    - ##### Rest ...params: any[]

    #### Returns T

### TypeDivider

TypeDivider: string

- Defined in themes/structure/Palette.ts:30

### foo

foo: Partial<Fields>

- Defined in lib/component-mapper/objectMapper.ts:59

## Variables

### Const ActivityIndicator

ActivityIndicator: ComponentClass<ActivityIndicatorProps, any> | FunctionComponent<ActivityIndicatorProps> = getComponent<ActivityIndicatorProps>('ActivityIndicator')

- Defined in getComponent.tsx:54

### Const BlueBaseConsumer

BlueBaseConsumer: ExoticComponent<ConsumerProps<BlueBase>> = BlueBaseContext.Consumer

- Defined in Context.tsx:6

### Const BlueBaseContext

BlueBaseContext: Context<BlueBase> = createContext(undefined as any)

- Defined in Context.tsx:4

### Const BlueBaseProvider

BlueBaseProvider: ProviderExoticComponent<ProviderProps<BlueBase>> = BlueBaseContext.Provider

- Defined in Context.tsx:5

### Const Body1

Body1: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('Body1')

- Defined in getComponent.tsx:69

### Const Body2

Body2: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('Body2')

- Defined in getComponent.tsx:70

### Const Caption

Caption: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('Caption')

- Defined in getComponent.tsx:71

### Const DEFAULT_HOOK_PRIORITY

DEFAULT_HOOK_PRIORITY: 10 = 10

- Defined in registries/HookRegistry.ts:23

Default priority for a hook.

### Const H1

H1: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('H1')

- Defined in getComponent.tsx:61

### Const H2

H2: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('H2')

- Defined in getComponent.tsx:62

### Const H3

H3: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('H3')

- Defined in getComponent.tsx:63

### Const H4

H4: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('H4')

- Defined in getComponent.tsx:64

### Const H5

H5: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('H5')

- Defined in getComponent.tsx:65

### Const H6

H6: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('H6')

- Defined in getComponent.tsx:66

### Const Image

Image: ComponentClass<ImageProps, any> | FunctionComponent<ImageProps> = getComponent<ImageProps>('Image')

- Defined in getComponent.tsx:56

### Const MISSING_ERROR

MISSING_ERROR: "An unknown error occured." = "An unknown error occured."

- Defined in components/BlueBaseApp/BlueBaseApp.tsx:5
- Defined in components/ErrorObserver/ErrorObserver.tsx:6

### Const Overline

Overline: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('Overline')

- Defined in getComponent.tsx:72

### Const Subtitle1

Subtitle1: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('Subtitle1')

- Defined in getComponent.tsx:67

### Const Subtitle2

Subtitle2: ComponentClass<TextProps, any> | FunctionComponent<TextProps> = getComponent<TextProps>('Subtitle2')

- Defined in getComponent.tsx:68

### Const ThemeConsumer

ThemeConsumer: ExoticComponent<ConsumerProps<ThemeContextData>> = ThemeContext.Consumer

- Defined in themes/ThemeContext.tsx:53

BlueBase theme consumer.

### Const ThemeContext

ThemeContext: Context<ThemeContextData> = createContext(undefined as any)

- Defined in themes/ThemeContext.tsx:48

This is the context where BlueBase theme is stored.

### Const View

View: ComponentClass<ViewProps, any> | FunctionComponent<ViewProps> = getComponent<ViewProps>('View')

- Defined in getComponent.tsx:58

### Const collection

collection: PluginCollection = [{enabled: true,key: 'a',value: {components: { A: Noop }},}, {enabled: false,key: 'b',value: {components: { B: Noop }},}, {enabled: true,key: 'c',value: {components: { C: Noop }},}]

- Defined in hooks/__tests__/plugins.test.tsx:10

### Const fontFamily

fontFamily: ""Roboto", "Helvetica", "Arial", sans-serif" | "Roboto" = isWeb ? '"Roboto", "Helvetica", "Arial", sans-serif' : 'Roboto'

- Defined in themes/helpers/createTypography.ts:17

### Const global

global: any

- Defined in utils/tests/Misc.test.ts:3

### Const isWeb

isWeb: boolean = Platform.OS === 'web'

- Defined in themes/helpers/createTypography.ts:5

### Const palette

palette: object = createPalette('light')

- Defined in themes/themes/BlueBaseDarkTheme.ts:6
- Defined in themes/themes/BlueBaseLightTheme.ts:6

#### Type declaration

### process

process: any

- Defined in utils/Misc.ts:1

### Const theme

theme: object = createTheme(palette, typography)

- Defined in themes/themes/BlueBaseDarkTheme.ts:8
- Defined in themes/themes/BlueBaseLightTheme.ts:8

#### Type declaration

- ##### components: object

- ##### palette: Palette

- ##### typography: ThemeTypography

- ##### shape: object

  - ##### borderRadius: number

- ##### spacing: object

  - ##### unit: number

### Const typography

typography: object = createTypography(palette)

- Defined in themes/themes/BlueBaseDarkTheme.ts:7
- Defined in themes/themes/BlueBaseLightTheme.ts:7

#### Type declaration

- ##### body1: any

- ##### body2: any

- ##### button: any

- ##### caption: any

- ##### h1: any

- ##### h2: any

- ##### h3: any

- ##### h4: any

- ##### h5: any

- ##### h6: any

- ##### overline: any

- ##### subtitle1: any

- ##### subtitle2: any

## Functions

### Const Bang

- Bang(): never
- Bang(): never
- Bang(): never

- - Defined in components/BlueBaseApp/__tests__/BlueBaseApp.test.tsx:10

  #### Returns never

- - Defined in components/ErrorObserver/__stories__/ErrorObserver.stories.tsx:5

  #### Returns never

- - Defined in components/ErrorObserver/__tests__/ErrorObserver.test.tsx:7

  #### Returns never

### Const BangNull

- BangNull(): never
- BangNull(): never

- - Defined in components/BlueBaseApp/__tests__/BlueBaseApp.test.tsx:14

  #### Returns never

- - Defined in components/ErrorObserver/__tests__/ErrorObserver.test.tsx:11

  #### Returns never

### Const Button

- Button(): Element

- - Defined in registries/__tests__/ComponentRegisty.test.tsx:10

  A basic button component that should render nicely on any platform. Supports a minimal level of customization.

  #### Returns Element

### constructor

- new Button(props: Readonly<ButtonProps>): Button
- new Button(props: ButtonProps, context?: any): Button

- Inherited from Component.__constructor

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:392

  #### Parameters

  - ##### props: Readonly<ButtonProps>

  #### Returns Button

- Inherited from Component.__constructor

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:394
  deprecated
  see

    https://reactjs.org/docs/legacy-context.html

  #### Parameters

  - ##### props: ButtonProps

  - ##### Optional context: any

  #### Returns Button

### context

context: any

Inherited from Component.context

- Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:392

If using the new style context, re-declare this in your class to be the `React.ContextType` of your `static contextType`.

    static contextType = MyContext
    context!: React.ContextType<typeof MyContext>

deprecated

  if used without a type annotation, or without static contextType

see

  https://reactjs.org/docs/legacy-context.html

### props

props: Readonly<object> & Readonly<ButtonProps>

Inherited from Component.props

- Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:417

### refs

refs: object

Inherited from Component.refs

- Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:423

deprecated

  https://reactjs.org/docs/refs-and-the-dom.html#legacy-api-string-refs

#### Type declaration

- ##### [key: string]: ReactInstance

### state

state: Readonly<S>

Inherited from Component.state

- Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:418

### Static Optional contextType

contextType: Context<any>

Inherited from Component.contextType

- Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:377

If set, `this.context` will be set at runtime to the current value of the given Context.

Usage:

    type MyContext = number
    const Ctx = React.createContext<MyContext>(0)

    class Foo extends React.Component {
      static contextType = Ctx
      context!: React.ContextType<typeof Ctx>
      render () {
        return <>My context's value: {this.context}</>;
      }
    }

see

  https://reactjs.org/docs/context.html#classcontexttype

### Optional UNSAFE_componentWillMount

- UNSAFE_componentWillMount(): void

- Inherited from DeprecatedLifecycle.UNSAFE_componentWillMount

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:605

  Called immediately before mounting occurs, and before `Component#render`. Avoid introducing any side-effects or subscriptions in this method.

  This method will not stop working in React 17.

  Note: the presence of getSnapshotBeforeUpdate or getDerivedStateFromProps prevents this from being invoked.

  deprecated

    16.3, use componentDidMount or the constructor instead

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#initializing-state

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#gradual-migration-path

  #### Returns void

### Optional UNSAFE_componentWillReceiveProps

- UNSAFE_componentWillReceiveProps(nextProps: Readonly<ButtonProps>, nextContext: any): void

- Inherited from DeprecatedLifecycle.UNSAFE_componentWillReceiveProps

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:637

  Called when the component may be receiving new props. React may call this even if props have not changed, so be sure to compare new and existing props if you only want to handle changes.

  Calling `Component#setState` generally does not trigger this method.

  This method will not stop working in React 17.

  Note: the presence of getSnapshotBeforeUpdate or getDerivedStateFromProps prevents this from being invoked.

  deprecated

    16.3, use static getDerivedStateFromProps instead

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#updating-state-based-on-props

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#gradual-migration-path

  #### Parameters

  - ##### nextProps: Readonly<ButtonProps>

  - ##### nextContext: any

  #### Returns void

### Optional UNSAFE_componentWillUpdate

- UNSAFE_componentWillUpdate(nextProps: Readonly<ButtonProps>, nextState: Readonly<S>, nextContext: any): void

- Inherited from DeprecatedLifecycle.UNSAFE_componentWillUpdate

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:665

  Called immediately before rendering when new props or state is received. Not called for the initial render.

  Note: You cannot call `Component#setState` here.

  This method will not stop working in React 17.

  Note: the presence of getSnapshotBeforeUpdate or getDerivedStateFromProps prevents this from being invoked.

  deprecated

    16.3, use getSnapshotBeforeUpdate instead

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#reading-dom-properties-before-an-update

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#gradual-migration-path

  #### Parameters

  - ##### nextProps: Readonly<ButtonProps>

  - ##### nextState: Readonly<S>

  - ##### nextContext: any

  #### Returns void

### Optional componentDidCatch

- componentDidCatch(error: Error, errorInfo: ErrorInfo): void

- Inherited from ComponentLifecycle.componentDidCatch

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:534

  Catches exceptions generated in descendant components. Unhandled exceptions will cause the entire component tree to unmount.

  #### Parameters

  - ##### error: Error

  - ##### errorInfo: ErrorInfo

  #### Returns void

### Optional componentDidMount

- componentDidMount(): void

- Inherited from ComponentLifecycle.componentDidMount

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:513

  Called immediately after a component is mounted. Setting state here will trigger re-rendering.

  #### Returns void

### Optional componentDidUpdate

- componentDidUpdate(prevProps: Readonly<ButtonProps>, prevState: Readonly<S>, snapshot?: SS): void

- Inherited from NewLifecycle.componentDidUpdate

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:576

  Called immediately after updating occurs. Not called for the initial render.

  The snapshot is only present if getSnapshotBeforeUpdate is present and returns non-null.

  #### Parameters

  - ##### prevProps: Readonly<ButtonProps>

  - ##### prevState: Readonly<S>

  - ##### Optional snapshot: SS

  #### Returns void

### Optional componentWillMount

- componentWillMount(): void

- Inherited from DeprecatedLifecycle.componentWillMount

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:591

  Called immediately before mounting occurs, and before `Component#render`. Avoid introducing any side-effects or subscriptions in this method.

  Note: the presence of getSnapshotBeforeUpdate or getDerivedStateFromProps prevents this from being invoked.

  deprecated

    16.3, use componentDidMount or the constructor instead; will stop working in React 17

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#initializing-state

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#gradual-migration-path

  #### Returns void

### Optional componentWillReceiveProps

- componentWillReceiveProps(nextProps: Readonly<ButtonProps>, nextContext: any): void

- Inherited from DeprecatedLifecycle.componentWillReceiveProps

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:620

  Called when the component may be receiving new props. React may call this even if props have not changed, so be sure to compare new and existing props if you only want to handle changes.

  Calling `Component#setState` generally does not trigger this method.

  Note: the presence of getSnapshotBeforeUpdate or getDerivedStateFromProps prevents this from being invoked.

  deprecated

    16.3, use static getDerivedStateFromProps instead; will stop working in React 17

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#updating-state-based-on-props

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#gradual-migration-path

  #### Parameters

  - ##### nextProps: Readonly<ButtonProps>

  - ##### nextContext: any

  #### Returns void

### Optional componentWillUnmount

- componentWillUnmount(): void

- Inherited from ComponentLifecycle.componentWillUnmount

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:529

  Called immediately before a component is destroyed. Perform any necessary cleanup in this method, such as cancelled network requests, or cleaning up any DOM elements created in `componentDidMount`.

  #### Returns void

### Optional componentWillUpdate

- componentWillUpdate(nextProps: Readonly<ButtonProps>, nextState: Readonly<S>, nextContext: any): void

- Inherited from DeprecatedLifecycle.componentWillUpdate

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:650

  Called immediately before rendering when new props or state is received. Not called for the initial render.

  Note: You cannot call `Component#setState` here.

  Note: the presence of getSnapshotBeforeUpdate or getDerivedStateFromProps prevents this from being invoked.

  deprecated

    16.3, use getSnapshotBeforeUpdate instead; will stop working in React 17

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#reading-dom-properties-before-an-update

  see

    https://reactjs.org/blog/2018/03/27/update-on-async-rendering.html#gradual-migration-path

  #### Parameters

  - ##### nextProps: Readonly<ButtonProps>

  - ##### nextState: Readonly<S>

  - ##### nextContext: any

  #### Returns void

### forceUpdate

- forceUpdate(callBack?: undefined | function): void

- Inherited from Component.forceUpdate

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:409

  #### Parameters

  - ##### Optional callBack: undefined | function

  #### Returns void

### Optional getSnapshotBeforeUpdate

- getSnapshotBeforeUpdate(prevProps: Readonly<ButtonProps>, prevState: Readonly<S>): SS | null

- Inherited from NewLifecycle.getSnapshotBeforeUpdate

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:570

  Runs before React applies the result of `render` to the document, and returns an object to be given to componentDidUpdate. Useful for saving things such as scroll position before `render` causes changes to it.

  Note: the presence of getSnapshotBeforeUpdate prevents any of the deprecated lifecycle events from running.

  #### Parameters

  - ##### prevProps: Readonly<ButtonProps>

  - ##### prevState: Readonly<S>

  #### Returns SS | null

### render

- render(): Element

- Overrides Component.render

  - Defined in native/Button/Button.tsx:120

  #### Returns Element

### setState

- setState<K>(state: function | null | S | object, callback?: undefined | function): void

- Inherited from Component.setState

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:404

  #### Type parameters

  - #### K: keyof S

  #### Parameters

  - ##### state: function | null | S | object

  - ##### Optional callback: undefined | function

  #### Returns void

### Optional shouldComponentUpdate

- shouldComponentUpdate(nextProps: Readonly<ButtonProps>, nextState: Readonly<S>, nextContext: any): boolean

- Inherited from ComponentLifecycle.shouldComponentUpdate

  - Defined in /Users/artalat/Coding/bluebase/core/node_modules/@types/react/index.d.ts:524

  Called to determine whether the change in props and state should trigger a re-render.

  `Component` always returns true. `PureComponent` implements a shallow comparison on props and state and returns true if any props or states have changed.

  If false is returned, `Component#render`, `componentWillUpdate` and `componentDidUpdate` will not be called.

  #### Parameters

  - ##### nextProps: Readonly<ButtonProps>

  - ##### nextState: Readonly<S>

  - ##### nextContext: any

  #### Returns boolean

### Static defaultStyles

- defaultStyles(theme: Theme): object

- - Defined in native/Button/Button.tsx:84

  #### Parameters

  - ##### theme: Theme

  #### Returns object

  - ##### defaultText: object

  - ##### link: object

  - ##### linkText: object

  - ##### default: object

    - ##### backgroundColor: string

  - ##### fullWidth: object

    - ##### alignSelf: string

  - ##### primary: object

    - ##### backgroundColor: string

  - ##### primaryText: object

    - ##### color: string

  - ##### root: object

    - ##### alignSelf: string

    - ##### borderRadius: number

    - ##### paddingBottom: number

    - ##### paddingLeft: number

    - ##### paddingRight: number

    - ##### paddingTop: number

  - ##### secondary: object

    - ##### backgroundColor: string

  - ##### secondaryText: object

    - ##### color: string

  - ##### text: object

    - ##### textAlign: string

### Const EmptyState

- EmptyState(_props: EmptyStateProps): Element

- - Defined in components/EmptyState/EmptyState.tsx:6

  #### Parameters

  - ##### _props: EmptyStateProps

  #### Returns Element

### Const HOC

- HOC(Comp: React.ComponentType): (Anonymous function)

- - Defined in registries/__stories__/ComponentRegistry.stories.tsx:6

  #### Parameters

  - ##### Comp: React.ComponentType

  #### Returns (Anonymous function)

### Const Noop

- Noop(): null

- - Defined in components/Noop/Noop.tsx:1

  #### Returns null

### Const Post

- Post(__namedParameters: object): Element

- - Defined in lib/json-schema-parser/tests/JsonSchemaParser.test.tsx:7

  #### Parameters

  - ##### __namedParameters: object

    - ##### content: any

    - ##### rest: any

  #### Returns Element

### Const ReactLoadableLoading

- ReactLoadableLoading(props: LoadingComponentProps): null | Element

- - Defined in components/ReactLoadableLoading/ReactLoadableLoading.tsx:9

  Loading component used in react-loadable library

  #### Parameters

  - ##### props: LoadingComponentProps

  #### Returns null | Element

### Const Text

- Text(__namedParameters: object): Element

- - Defined in native/Text/Text.tsx:11

  #### Parameters

  - ##### __namedParameters: object

    - ##### rest: rest

    - ##### style: undefined | null | false | TextStyle | number & object | RecursiveArray<undefined | null | false | TextStyle | number & object>

    - ##### styles: undefined | object

  #### Returns Element

### Const ThirdPartyButton

- ThirdPartyButton(props: ThirdPartyButtonProps): Element

- - Defined in lib/component-mapper/tests/componentMapper.test.tsx:14

  #### Parameters

  - ##### props: ThirdPartyButtonProps

  #### Returns Element

### Const Timeline

- Timeline(__namedParameters: object): Element

- - Defined in lib/json-schema-parser/tests/JsonSchemaParser.test.tsx:6

  #### Parameters

  - ##### __namedParameters: object

    - ##### children: any

    - ##### rest: any

  #### Returns Element

### Const applyStyles

- applyStyles(name: string, Component: ComponentWithDefaultStyles, stylesParam: MaybeThunk<ComponentStyles>): React.ComponentType<any>

- - Defined in themes/helpers/applyStyles.tsx:33

  Merges component styles from different sources and passes on the the component as 'styles' prop.

  Following sources are considered as style sources. (In order of least important first):

  1. defaultStyles: A component may provide default styles as a "defaultStyles" static property of component. This is similar to defaultProps in react.
  2. stylesParam: 3rd property of this function. Note: Component Registry passes 'styles' prop from it's registry item.
  3. Themes: From theme.components[componentName] property of current theme.
  4. styles prop: The styles prop passed on to the component during usage.

  FIXME: Fix return typing of this function

  #### Parameters

  - ##### name: string

  - ##### Component: ComponentWithDefaultStyles

  - ##### stylesParam: MaybeThunk<ComponentStyles>

  #### Returns React.ComponentType<any>

### Const buildTheme

- buildTheme(mode?: "light" | "dark"): (Anonymous function)

- - Defined in themes/helpers/buildTheme.ts:5

  #### Parameters

  - ##### Default value mode: "light" | "dark" = "light"

  #### Returns (Anonymous function)

### componentMapper

- componentMapper<Props>(Component: React.ComponentType<any>, fields: Fields): React.ComponentType<Props>

- - Defined in lib/component-mapper/componentMapper.tsx:17

  A React HOC to map components

  Example 1:

  Material UI Button: <MUI.Button label="ABC" /> BlueBase BUtton: <BB.Components.Button>{label}</BB.Components.Button>

  So BB.Components.Button = componentMapper(MUI.Button, { label: children });

  #### Type parameters

  - #### Props

  #### Parameters

  - ##### Component: React.ComponentType<any>

  - ##### fields: Fields

  #### Returns React.ComponentType<Props>

### createBlueBaseModule

- createBlueBaseModule<T>(input: MaybeBlueBaseModule<T>): BlueBaseModule<T>

- - Defined in utils/BlueBaseModule.ts:52

  Creates a BlueBaseModule promise

  #### Type parameters

  - #### T

  #### Parameters

  - ##### input: MaybeBlueBaseModule<T>

  #### Returns BlueBaseModule<T>

### createPalette

- createPalette(mode: "light" | "dark"): object

- - Defined in themes/helpers/createPalette.ts:90

  #### Parameters

  - ##### mode: "light" | "dark"

  #### Returns object

### createPlugin

- createPlugin(plugin: Plugin): PluginInput

- - Defined in registries/PluginRegistry.ts:90

  Creates a BlueBase plugin from input params

  #### Parameters

  - ##### plugin: Plugin

  #### Returns PluginInput

### createTheme

- createTheme(palette: Palette, typography: ThemeTypography): object

- - Defined in themes/helpers/createTheme.ts:3

  #### Parameters

  - ##### palette: Palette

  - ##### typography: ThemeTypography

  #### Returns object

  - ##### components: object

  - ##### palette: Palette

  - ##### typography: ThemeTypography

  - ##### shape: object

    - ##### borderRadius: number

  - ##### spacing: object

    - ##### unit: number

### createTypography

- createTypography(palette: Palette): object

- - Defined in themes/helpers/createTypography.ts:19

  #### Parameters

  - ##### palette: Palette

  #### Returns object

  - ##### body1: any

  - ##### body2: any

  - ##### button: any

  - ##### caption: any

  - ##### h1: any

  - ##### h2: any

  - ##### h3: any

  - ##### h4: any

  - ##### h5: any

  - ##### h6: any

  - ##### overline: any

  - ##### subtitle1: any

  - ##### subtitle2: any

### Const getComponent

- getComponent<T>(...keys: string[]): ComponentClass<T, any> | FunctionComponent<T>
- getComponent(BB: BlueBase): (Anonymous function)

- - Defined in getComponent.tsx:20

  #### Type parameters

  - #### T

  #### Parameters

  - ##### Rest ...keys: string[]

  #### Returns ComponentClass<T, any> | FunctionComponent<T>

- - Defined in components/JsonSchema/JsonSchema.tsx:14

  #### Parameters

  - ##### BB: BlueBase

  #### Returns (Anonymous function)

### getDefiniteArray

- getDefiniteArray<T>(input: MaybeArray<T>): T[]

- - Defined in utils/Collections.ts:10

  If an input is an array, returns as is. Otherwise creates a new array with input object at index 0 and returns it.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### input: MaybeArray<T>

    Input object

  #### Returns T[]

### getDefiniteBlueBaseModule

- getDefiniteBlueBaseModule<T>(input: MaybeBlueBaseModule<T>): BlueBaseModule<T>

- - Defined in utils/BlueBaseModule.ts:78

  Checks if an input object is a BlueBaseModule. Returns as is if true, otherwise, wraps the input into a BlueBaseModule and returns.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### input: MaybeBlueBaseModule<T>

    Input object

  #### Returns BlueBaseModule<T>

### getDefiniteModule

- getDefiniteModule<T>(object: MaybeEsModule<T>): T

- - Defined in utils/Modules.ts:19

  If an input object is an ES module, returns object.default, otherwise returns the object as is.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: MaybeEsModule<T>

    Input object

  #### Returns T

### getDefinitePromise

- getDefinitePromise<T>(object: MaybePromise<T>): Promise<T>

- - Defined in utils/Promises.ts:11

  Take an input obect. If the input is a promise, returns as is. Other wise creates a promise that resolves the input.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: MaybePromise<T>

    Input object

  #### Returns Promise<T>

### inputToPlugin

- inputToPlugin(plugin: PluginInput): Plugin

- - Defined in registries/PluginRegistry.ts:70

  #### Parameters

  - ##### plugin: PluginInput

  #### Returns Plugin

### isBlueBaseModule

- isBlueBaseModule<T>(input: MaybeBlueBaseModule<T>): boolean

- - Defined in utils/BlueBaseModule.ts:90

  Check if an input object is an instance of BlueBaseModule

  #### Type parameters

  - #### T

  #### Parameters

  - ##### input: MaybeBlueBaseModule<T>

    Input object

  #### Returns boolean

### isEsModule

- isEsModule<T>(object: any): boolean

- - Defined in utils/Modules.ts:27

  Checks if an object is an ES module.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: any

    Input object

  #### Returns boolean

### isProduction

- isProduction(): boolean

- - Defined in utils/Misc.ts:6

  Check if the project is running in production mode. Returns 'true' if it is.

  #### Returns boolean

### isPromise

- isPromise<T>(object: any): boolean

- - Defined in utils/Promises.ts:19

  Checks if an object is a Promise

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: any

    Input object

  #### Returns boolean

### isThunk

- isThunk<T>(input: MaybeThunk<T>): boolean

- - Defined in utils/Thunks.ts:26

  Checks if an object is a thunk (function).

  #### Type parameters

  - #### T

  #### Parameters

  - ##### input: MaybeThunk<T>

    Object to test

  #### Returns boolean

### makeId

- makeId(length?: number): string

- - Defined in utils/Misc.ts:24

  Creates a unique ID.

  #### Parameters

  - ##### Default value length: number = 8

  #### Returns string

### objectMapper

- objectMapper(obj: any, fields: Fields): any

- - Defined in lib/component-mapper/objectMapper.ts:32

  Example 1:

  mapObject({ foo: 'bar' })

  #### Parameters

  - ##### obj: any

  - ##### fields: Fields

  #### Returns any

### processMapperFields

- processMapperFields(fields: Fields): FieldsInternal

- - Defined in lib/component-mapper/objectMapper.ts:14

  #### Parameters

  - ##### fields: Fields

  #### Returns FieldsInternal

### renderChildrenWithProps

- renderChildrenWithProps<T>(children: MaybeRenderPropChildren<T>, props: T): any

- - Defined in utils/Components.ts:5

  #### Type parameters

  - #### T

  #### Parameters

  - ##### children: MaybeRenderPropChildren<T>

  - ##### props: T

  #### Returns any

### resolveThunk

- resolveThunk<T>(input: MaybeThunk<T>, ...params: any[]): T

- - Defined in utils/Thunks.ts:18

  If the input object is a thunk (function), then executes the function and returns the result. If the input object is not a thunk, it is returned as is.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### input: MaybeThunk<T>

    The object to evaluate

  - ##### Rest ...params: any[]

    Any params that need to be passed onto the thunk during execution

  #### Returns T

## Object literals

### Const BlueBaseDarkTheme

BlueBaseDarkTheme: object

- Defined in themes/themes/BlueBaseDarkTheme.ts:10

### alternate

alternate: string = "bluebase-light"

- Defined in themes/themes/BlueBaseDarkTheme.ts:11

### key

key: string = "bluebase-dark"

- Defined in themes/themes/BlueBaseDarkTheme.ts:12

### mode

mode: string = "dark"

- Defined in themes/themes/BlueBaseDarkTheme.ts:13

### name

name: string = "BlueBase Dark"

- Defined in themes/themes/BlueBaseDarkTheme.ts:14

### value

value: object = theme

- Defined in themes/themes/BlueBaseDarkTheme.ts:15

#### Type declaration

- ##### components: object

- ##### palette: Palette

- ##### typography: ThemeTypography

- ##### shape: object

  - ##### borderRadius: number

- ##### spacing: object

  - ##### unit: number

### Const BlueBaseDefaultConfigs

BlueBaseDefaultConfigs: object

- Defined in Configs.ts:41

### debug

debug: boolean = !isProduction()

- Defined in Configs.ts:42

### development

development: boolean = !isProduction()

- Defined in Configs.ts:43

### direction

direction: "ltr" = "ltr"

- Defined in Configs.ts:44

### locale

locale: string = "en"

- Defined in Configs.ts:45

### theme.mode

theme.mode: "light" = "light"

- Defined in Configs.ts:46

### theme.name

theme.name: string = "bluebase-light"

- Defined in Configs.ts:47

### theme.overrides

theme.overrides: object

- Defined in Configs.ts:48

#### Type declaration

### title

title: string = "BlueBase"

- Defined in Configs.ts:49

### Const BlueBaseLightTheme

BlueBaseLightTheme: object

- Defined in themes/themes/BlueBaseLightTheme.ts:10

### alternate

alternate: string = "bluebase-dark"

- Defined in themes/themes/BlueBaseLightTheme.ts:11

### key

key: string = "bluebase-light"

- Defined in themes/themes/BlueBaseLightTheme.ts:12

### mode

mode: string = "light"

- Defined in themes/themes/BlueBaseLightTheme.ts:13

### name

name: string = "BlueBase Light"

- Defined in themes/themes/BlueBaseLightTheme.ts:14

### value

value: object = theme

- Defined in themes/themes/BlueBaseLightTheme.ts:15

#### Type declaration

- ##### components: object

- ##### palette: Palette

- ##### typography: ThemeTypography

- ##### shape: object

  - ##### borderRadius: number

- ##### spacing: object

  - ##### unit: number

### Const FontWeight

FontWeight: object

- Defined in themes/helpers/createTypography.ts:7

### light

light: string = "300"

- Defined in themes/helpers/createTypography.ts:8

### medium

medium: string = "500"

- Defined in themes/helpers/createTypography.ts:10

### regular

regular: string = "400"

- Defined in themes/helpers/createTypography.ts:9

### Const boot

boot: object

- Defined in hooks/boot.ts:4

### bluebase.boot

bluebase.boot: object[] = [{key: 'bluebase-boot-default',priority: 5,// tslint:disable-next-line:object-literal-sort-keysvalue: async (bootOptions: BootOptions, _ctx: {}, BB: BlueBase) => {await BB.Hooks.run('bluebase.boot.start', bootOptions);await BB.Hooks.run('bluebase.components.register', bootOptions);await BB.Hooks.run('bluebase.configs.register', bootOptions);await BB.Hooks.run('bluebase.hooks.register', bootOptions.hooks);await BB.Hooks.run('bluebase.routes.register', bootOptions);await BB.Hooks.run('bluebase.themes.register', bootOptions);await BB.Hooks.run('bluebase.plugins.register', bootOptions.plugins);await BB.Hooks.run('bluebase.plugins.initialize.all', bootOptions);await BB.Hooks.run('bluebase.boot.end', bootOptions);return bootOptions;},},]

- Defined in hooks/boot.ts:5

### bluebase.boot.start

bluebase.boot.start: object[] = [{key: 'system-initialize-default',priority: 5,// tslint:disable-next-line:object-literal-sort-keysvalue: async (bootOptions: BootOptions, _ctx: {}, BB: BlueBase) => {await BB.Hooks.run('bluebase.components.register.internal', bootOptions);return bootOptions;},},]

- Defined in hooks/boot.ts:30

### Const caseAllCaps

caseAllCaps: object

- Defined in themes/helpers/createTypography.ts:13

### textTransform

textTransform: string = "uppercase"

- Defined in themes/helpers/createTypography.ts:14

### Const common

common: object

- Defined in themes/helpers/createPalette.ts:69

### error

error: object

- Defined in themes/helpers/createPalette.ts:70

### contrastText

contrastText: string = "#fff"

- Defined in themes/helpers/createPalette.ts:71

### dark

dark: string = "#d32f2f"

- Defined in themes/helpers/createPalette.ts:72

### light

light: string = "#e57373"

- Defined in themes/helpers/createPalette.ts:73

### main

main: string = "#f44336"

- Defined in themes/helpers/createPalette.ts:74

### primary

primary: object

- Defined in themes/helpers/createPalette.ts:76

### contrastText

contrastText: string = "#fff"

- Defined in themes/helpers/createPalette.ts:77

### dark

dark: string = "#303f9f"

- Defined in themes/helpers/createPalette.ts:78

### light

light: string = "#7986cb"

- Defined in themes/helpers/createPalette.ts:79

### main

main: string = "#3f51b5"

- Defined in themes/helpers/createPalette.ts:80

### secondary

secondary: object

- Defined in themes/helpers/createPalette.ts:82

### contrastText

contrastText: string = "#fff"

- Defined in themes/helpers/createPalette.ts:83

### dark

dark: string = "#c51162"

- Defined in themes/helpers/createPalette.ts:84

### light

light: string = "#ff4081"

- Defined in themes/helpers/createPalette.ts:85

### main

main: string = "#f50057"

- Defined in themes/helpers/createPalette.ts:86

### Const components

components: object

- Defined in hooks/components.ts:25

### bluebase.components.register

bluebase.components.register: object[] = [{key: 'bluebase-components-register-default',priority: 5,// tslint:disable-next-line:object-literal-sort-keysvalue: async (bootOptions: BootOptions, _ctx: {}, BB: BlueBase) => {await BB.Components.registerCollection(bootOptions.components);return bootOptions;},},]

- Defined in hooks/components.ts:120

This hook registers components from bootOptions.components property. These are the components typically set in the bluebase.js file.

### bluebase.components.register.internal

bluebase.components.register.internal: object[] = [{key: 'bluebase-components-register-internal-default',priority: 5,value: async (bootOptions: BootOptions, _ctx: {}, BB: BlueBase) => {await BB.Components.registerCollection({// BlueBase ComponentsBlueBaseHook,ComponentState,DataObserver,DynamicIcon,EmptyState,ErrorObserver,ErrorState,HoverObserver,Icon: Noop,JsonSchema,LoadingState,Noop,PluginIcon,StatefulComponent,SystemApp,SystemContent,SystemFooter: Noop,SystemHeader: Noop,WaitObserver,// Native...Native,// TypographyH1: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.h1 }),},H2: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.h2 }),},H3: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.h3 }),},H4: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.h4 }),},H5: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.h5 }),},H6: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.h6 }),},Subtitle1: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.subtitle1 }),},Subtitle2: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.subtitle2 }),},Body1: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.body1 }),},Body2: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.body2 }),},Caption: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.caption }),},Overline: {value: Native.Text,styles: (theme: ThemeValue) => ({ root: theme.typography.overline }),},});return bootOptions;},},]

- Defined in hooks/components.ts:29

Registers all components that ship with BlueBase

### Const configs

configs: object

- Defined in hooks/configs.ts:5
- Defined in registries/__tests__/ConfigRegistry.test.ts:5

### bluebase.configs.register

bluebase.configs.register: object[] = [{key: 'bluebase-configs-register-default',priority: 5,// tslint:disable-next-line:object-literal-sort-keysvalue: async (bootOptions: BootOptions, _ctx: {}, BB: BlueBase) => {await BB.Configs.registerCollection(BlueBaseDefaultConfigs);await BB.Configs.registerCollection(bootOptions.configs);return bootOptions;},},]

- Defined in hooks/configs.ts:6

### plugin.another.check

plugin.another.check: boolean = true

- Defined in registries/__tests__/ConfigRegistry.test.ts:10

### plugin.test.bar

plugin.test.bar: number = 10

- Defined in registries/__tests__/ConfigRegistry.test.ts:9

### plugin.test.foo

plugin.test.foo: number = 5

- Defined in registries/__tests__/ConfigRegistry.test.ts:8

### subtitle

subtitle: string = "We are just testing"

- Defined in registries/__tests__/ConfigRegistry.test.ts:7

### title

title: string = "Config Registry Test"

- Defined in registries/__tests__/ConfigRegistry.test.ts:6

### Const dark

dark: object

- Defined in themes/helpers/createPalette.ts:46

### divider

divider: string = "rgba(255, 255, 255, 0.12)"

- Defined in themes/helpers/createPalette.ts:54

### action

action: object

- Defined in themes/helpers/createPalette.ts:59

### active

active: string = "#ffffff"

- Defined in themes/helpers/createPalette.ts:60

### disabled

disabled: string = "rgba(255, 255, 255, 0.3)"

- Defined in themes/helpers/createPalette.ts:64

### disabledBackground

disabledBackground: string = "rgba(255, 255, 255, 0.12)"

- Defined in themes/helpers/createPalette.ts:65

### hover

hover: string = "rgba(255, 255, 255, 0.1)"

- Defined in themes/helpers/createPalette.ts:61

### hoverOpacity

hoverOpacity: number = 0.1

- Defined in themes/helpers/createPalette.ts:62

### selected

selected: string = "rgba(255, 255, 255, 0.2)"

- Defined in themes/helpers/createPalette.ts:63

### background

background: object

- Defined in themes/helpers/createPalette.ts:55

### card

card: string = "#424242"

- Defined in themes/helpers/createPalette.ts:56

### default

default: string = "#303030"

- Defined in themes/helpers/createPalette.ts:57

### text

text: object

- Defined in themes/helpers/createPalette.ts:47

### disabled

disabled: string = "rgba(255, 255, 255, 0.5)"

- Defined in themes/helpers/createPalette.ts:50

### hint

hint: string = "rgba(255, 255, 255, 0.5)"

- Defined in themes/helpers/createPalette.ts:51

### icon

icon: string = "rgba(255, 255, 255, 0.5)"

- Defined in themes/helpers/createPalette.ts:52

### primary

primary: string = "#ffffff"

- Defined in themes/helpers/createPalette.ts:48

### secondary

secondary: string = "rgba(255, 255, 255, 0.7)"

- Defined in themes/helpers/createPalette.ts:49

### Const light

light: object

- Defined in themes/helpers/createPalette.ts:3

### divider

divider: string = "rgba(0, 0, 0, 0.12)"

- Defined in themes/helpers/createPalette.ts:19

The color used to divide different elements.

### action

action: object

- Defined in themes/helpers/createPalette.ts:31

The colors used to style the action elements.

### active

active: string = "rgba(0, 0, 0, 0.54)"

- Defined in themes/helpers/createPalette.ts:33

The color of an active action like an icon button.

### disabled

disabled: string = "rgba(0, 0, 0, 0.26)"

- Defined in themes/helpers/createPalette.ts:40

The color of a disabled action.

### disabledBackground

disabledBackground: string = "rgba(0, 0, 0, 0.12)"

- Defined in themes/helpers/createPalette.ts:42

The background color of a disabled action.

### hover

hover: string = "rgba(0, 0, 0, 0.08)"

- Defined in themes/helpers/createPalette.ts:35

The color of an hovered action.

### hoverOpacity

hoverOpacity: number = 0.08

- Defined in themes/helpers/createPalette.ts:36

### selected

selected: string = "rgba(0, 0, 0, 0.14)"

- Defined in themes/helpers/createPalette.ts:38

The color of a selected action.

### background

background: object

- Defined in themes/helpers/createPalette.ts:25

The background colors used to style the surfaces. Consistency between these values is important.

### card

card: string = "#ffffff"

- Defined in themes/helpers/createPalette.ts:26

### default

default: string = "#fafafa"

- Defined in themes/helpers/createPalette.ts:27

### text

text: object

- Defined in themes/helpers/createPalette.ts:5

The colors used to style the text.

### disabled

disabled: string = "rgba(0, 0, 0, 0.38)"

- Defined in themes/helpers/createPalette.ts:11

Disabled text have even lower visual prominence.

### hint

hint: string = "rgba(0, 0, 0, 0.38)"

- Defined in themes/helpers/createPalette.ts:13

Text hints.

### icon

icon: string = "rgba(0, 0, 0, 0.38)"

- Defined in themes/helpers/createPalette.ts:15

Icon color

### primary

primary: string = "rgba(0, 0, 0, 0.87)"

- Defined in themes/helpers/createPalette.ts:7

The most important text.

### secondary

secondary: string = "rgba(0, 0, 0, 0.54)"

- Defined in themes/helpers/createPalette.ts:9

Secondary text.

### Const plugins

plugins: object

- Defined in hooks/plugins.ts:4

### bluebase.plugins.initialize

bluebase.plugins.initialize: object[] = [{key: 'bluebase-plugins-initialize-default',priority: 5,// tslint:disable-next-line:object-literal-sort-keysvalue: async (plugin: Plugin, _args: any, BB: BlueBase) => {/////////////////////////////// Register Hooks ///////////////////////////////await BB.Hooks.registerNestedCollection(plugin.hooks);//////////////////////////////////// Register Components ////////////////////////////////////await BB.Components.registerCollection(plugin.components);//////////////////////////////// Register Themes ////////////////////////////////await BB.Themes.registerCollection(plugin.themes);///////////////////////////////// Register Configs /////////////////////////////////// Custom input configs are already registered at this point,// We just want to make sure we set default configs if certain// configs were not given as inputBB.Configs.registerCollectionIfNotExists(plugin.defaultConfigs);//////////////////////////////// Register Routes ////////////////////////////////// TODO: Implement route registeration// returnreturn plugin;},},]

- Defined in hooks/plugins.ts:48

Initializes a single plugin in BlueBase

### bluebase.plugins.initialize.all

bluebase.plugins.initialize.all: object[] = [{key: 'bluebase-plugins-initialize-all-default',priority: 5,// tslint:disable-next-line:object-literal-sort-keysvalue: async (noop: any, _args: any, BB: BlueBase) => {const enabledPlugins = BB.Plugins.filter((_value, key) => BB.Plugins.isEnabled(key));for (const plugin of Object.values(enabledPlugins)) {await BB.Hooks.run('bluebase.plugins.initialize', await BB.Plugins.resolve(plugin.key));}// returnreturn noop;},},]

- Defined in hooks/plugins.ts:26

Initializes all ENABLED plugins in BlueBase

### bluebase.plugins.register

bluebase.plugins.register: object[] = [{key: 'bluebase-plugins-register-default',priority: 5,// tslint:disable-next-line:object-literal-sort-keysvalue: async (pluginsCollection: BootOptions['plugins'], _args: any, BB: BlueBase) => {await BB.Plugins.registerCollection(pluginsCollection);// returnreturn pluginsCollection;},},]

- Defined in hooks/plugins.ts:8

Registers given list of plugins

### Const themes

themes: object

- Defined in hooks/themes.ts:5

### bluebase.themes.register

bluebase.themes.register: object[] = [{key: 'bluebase-themes-register-internal-default',priority: 5,// tslint:disable-line:object-literal-sort-keysvalue: async (bootOptions: BootOptions, _ctx: {}, BB: BlueBase) => {await BB.Themes.register(BlueBaseLightTheme);await BB.Themes.register(BlueBaseDarkTheme);await BB.Themes.registerCollection(bootOptions.themes);return bootOptions;},},]

- Defined in hooks/themes.ts:6

Generated using TypeDoc